rm( list=ls())

Wert1<-c('constant','low','moderate','high')

Mechtab<-matrix(NA,nrow=6)
for (i in 6:1){
  Mechtab<-cbind(Mechtab,rbind(combn(c("enzyme","depth","beach","shade","consdepth","consshade"),i),matrix("xx",nrow=6-i,ncol=choose(6,i))))
}
Mechtab[,1]<-c("none",rep("xx",5))
Mechtab<-Mechtab[,c(1,2,51,57,58:64)]
Wert2<-1:dim(Mechtab)[2]

Wert3<-c(50,100,200,1000)#area
repl <- 100 

XXX<-expand.grid(list(Wert1,Wert2,Wert3))
W1<-rep(XXX[,1],each=repl)
W2<-rep(XXX[,2],each=repl)
W3<-rep(XXX[,3],each=repl)

idx1 <- as.numeric(Sys.getenv('SLURM_PROCID'))+1 # get the processID

iterationnum <- as.numeric(commandArgs(trailingOnly=T))[1] #retrieve the parameter you want to use in this simulation.
cores_to_use <- as.numeric(commandArgs(trailingOnly=T))[2] #retrieve the parameter you want to use in this simulation.

idx2<-((1:cores_to_use)+(cores_to_use*(iterationnum-1)))[idx1]
if(!is.na(idx2)){ # use this to make sure, thare are parameters left for this simulation.
  W1<-W1[idx2]
  W2<-W2[idx2]
  W3<-W3[idx2]
  # setwd("C:/Users/cstock2/Documents/Turtles")
  #  idx2<-floor(runif(1,1,401))
  #-----------------------------

  climate <- c('constant','low','moderate','high')
  ######## TURTLE PROJECT ##########
  
  a <- 1          # calculated with f(t)=100/(1+a*exp(-b*t)) with f(28)=5 and f(29.3)=50
  b <- 0.4424779
  
  #conductivity <- .2 #http://www.chemie.de/lexikon/Temperaturleitfhigkeit.html
  # initiating parameters for first generation-----
  N <- 200# initial population size
  obs_time<-701
  area<-W3
  sexratio <- .5 # ratio of females in the beginning
  loci <- 3 # loci: nest depth, enzyme, shading
  timeframe <- seq(1800,2500)
  maturage<-40 #age of maturity
  ds<-numeric(obs_time+80)+0.9482 

  
  psurv <-.015 
  mura <- 0.01^2 # mutation rate
  K <- N # capacity of population
  southmate <- 0#W3 # chance of meeting southern male
  climate <- W1
  Mechanism <- Mechtab[,W2] # choose evolution/conservation mechanism
  # choose simulation parameters----
  
  old <- 29.3 # this is the temperature before climate change
  yearly <- 10 # move nests every 'yearly' years
 howmany <- 2 # how many nests should be moved (e.g.2 means every second nest)

  
  set.seed(idx2)
  

  egg_temp <- function(mechanism, year_temp,deep,shady,yearly,howmany){
    delta_t <- 0
    
    if ("beach"%in%mechanism){
      delta_t <- delta_t+switch(beach[i],-.7,0,.9) 
    }
    
    if ("enzyme"%in%mechanism){
      delta_t <- delta_t+(2*mean(egg[2,,ii])-1)
    }
    
    if (yearly > 0 && howmany > 0 && year>220&&(year/yearly)%%1==0&&(i/howmany)%%1==0&&"consdepth"%in%mechanism){    
      delta_t <- delta_t+(5.6*.9-.5*5.6)
    }else if ("depth"%in%mechanism){
      delta_t <- delta_t+(5.6*mean(genes[1,,i])-5.6*.5)
    }
    
    if (yearly > 0 && howmany > 0 && year>220&&(year/yearly)%%1==0&&(i/howmany)%%1==0&&"consshade"%in%mechanism){ 
      delta_t <- delta_t+(0.06*1*30-.9)
    }else if ("shade"%in%mechanism){
      delta_t <- delta_t+(0.06*mean(genes[3,,i])*30-0.9)
    }
    
    eggtemp <- year_temp-delta_t
    return(eggtemp)
  }
  
  
  temperature <- function(a,b,t){
    femprob <- (a/(1+exp(-(t-29.3)/b)))
    if (femprob>1){
      femprob <- 1
    }
    if (femprob<0){
      femprob <- 0
    }
    return(femprob)
  }
  
  
  estBetaParams <- function(mu, var) {
    if(mu>0.999){
      mu<-0.999
    }
    if(mu<0.001){
      mu<-0.001
    }
    alpha <- ((1 - mu) / var - 1 / mu) * mu ^ 2
    beta <- alpha * (1 / mu - 1)
    params <- list(alpha = alpha, beta = beta)
    return(params)
  }


  
  # load('SOUTHERN.RData')
  # southmales <-southern[,,which(southern[1,1,,W2]!=-1),W2]
  # make_south_egg <- function(mother,father){
  #   genes_father<-southern[,,father]
  #   genes_mother<-genes[,,mother]
  #   egg <- matrix(-1,nrow=loci,ncol=2)
  #   egg[1,1] <- sample(genes[1,,mother],1) # mother
  #   egg[1,2] <- sample(southern[1,,father],1) # father
  #   egg[1,c(1,2)]<-c( rbeta(1,estBetaParams(egg[1,1],mura)[[1]],estBetaParams(egg[1,1],mura)[[2]]), rbeta(1,estBetaParams(egg[1,2],mura)[[1]],estBetaParams(egg[1,2],mura)[[2]]))
  #   egg[2,1] <- sample(genes[2,,mother],1) # mother
  #   egg[2,2] <- sample(southern[2,,father],1) # father
  #   egg[2,c(1,2)]<-c( rbeta(1,estBetaParams(egg[2,1],mura)[[1]],estBetaParams(egg[2,1],mura)[[2]]), rbeta(1,estBetaParams(egg[2,2],mura)[[1]],estBetaParams(egg[2,2],mura)[[2]]))
  #   egg[3,1] <- sample(genes[3,,mother],1) # mother
  #   egg[3,2] <- sample(southern[3,,father],1) # father
  #   egg[3,c(1,2)]<-c( rbeta(1,estBetaParams(egg[3,1],mura)[[1]],estBetaParams(egg[3,1],mura)[[2]]), rbeta(1,estBetaParams(egg[3,2],mura)[[1]],estBetaParams(egg[3,2],mura)[[2]]))
  #   # mutation above: the alleles of the egg are changed according to a gamma distribution (and exp(log))
  #   return(egg)
  # }
  make_egg <- function(genes_mother,genes_father){
    genes2<-array(-1,dim=c(loci,2,2))
    genes2[,,1]<-genes_mother
    genes2[,,2]<-genes_father
    mother<-1
    father<-2
    egg <- matrix(-1,nrow=loci,ncol=2)
    egg[1,1] <- sample(genes2[1,,mother],1) # mother
    egg[1,2] <- sample(genes2[1,,father],1) # father
    egg[1,c(1,2)]<-c( rbeta(1,estBetaParams(egg[1,1],mura)[[1]],estBetaParams(egg[1,1],mura)[[2]]), rbeta(1,estBetaParams(egg[1,2],mura)[[1]],estBetaParams(egg[1,2],mura)[[2]]))
    egg[2,1] <- sample(genes2[2,,mother],1) # mother
    egg[2,2] <- sample(genes2[2,,father],1) # father
    egg[2,c(1,2)]<-c( rbeta(1,estBetaParams(egg[2,1],mura)[[1]],estBetaParams(egg[2,1],mura)[[2]]), rbeta(1,estBetaParams(egg[2,2],mura)[[1]],estBetaParams(egg[2,2],mura)[[2]]))
    egg[3,1] <- sample(genes2[3,,mother],1) # mother
    egg[3,2] <- sample(genes2[3,,father],1) # father
    egg[3,c(1,2)]<-c( rbeta(1,estBetaParams(egg[3,1],mura)[[1]],estBetaParams(egg[3,1],mura)[[2]]), rbeta(1,estBetaParams(egg[3,2],mura)[[1]],estBetaParams(egg[3,2],mura)[[2]]))
    
    return(egg)
  }
  
  # loop over parameters----
  
  popsize <- rep(NaN,obs_time)
  females <- rep(NaN,obs_time)
  meangene <- rep(NaN,obs_time)
  meanenzyme <- rep(NaN,obs_time)
  meanshade <- rep(NaN,obs_time)
  north <- rep(NaN,obs_time)
  east <- rep(NaN,obs_time)
  south <- rep(NaN,obs_time)
  meanshade <- rep(NaN,obs_time)
  nestdepth <- c(.1,.2,.3,.4,.5,.6,.7,.8,.9) # alleles for nest depth
  degreeshade <- nestdepth # alleles for degree of shading for the nest
  genes <- array(-1,dim=c(loci,2,K*10)) # population matrix
  startbabies<-loci*(maturage-1)*2*(K*.1)*2
  juveniles <- array(runif(K*2),dim=c(loci*(maturage-1),2,K*5)) # juvenile turtles get random value 0-1
  
  # # for shading, they get random value 0-30
  # for (juv in 1:(loci*(maturage-1))) {
  #   if((juv/3)%%1==0){
  #     juveniles[juv,,] <- sample(seq(0.1,0.9,0.1),4,replace=TRUE)
  #   }
  # }
  for(i in rev(seq(1,loci*(maturage-1),3))){
    aoaoa<-sample(1:(K*5)) #just creating a parameter name that has surely not been used yet...
    juveniles[i:(i+2),1,]<-rep(seq(0,1,length.out =K*5),3) [aoaoa]
    juveniles[i:(i+2),2,]<-rep(seq(0,1,length.out = K*5),3) [aoaoa]
  }
  juveniles[1:3,,]<--1
  # 
  genes[1,,1:N] <-runif(N*2,0,1) 
  genes[2,,1:N] <- runif(N*2,0,1) 
  genes[3,,1:N] <- runif(N*2,0,1) 
  ID <- 1:N
  id <- N
  sex <- rbinom(N+startbabies,1,sexratio) # 1 are females, 0 are males
  age <- c(ceiling(runif(N,(maturage-1),79)),rev(sort(rep(1:(maturage-1),length.out=startbabies)))) # starting population has N turtles aged 1-79
  #mated <- rep(0:3,length.out=N+startbabies) # how many years since the females mated
  mated <- rpois(N+startbabies,3) # how many years since the females mated
  beach <- sample(1:3, N+startbabies,replace=T) # each turtle has a beach on which it was born (1=north, 2=east, 3=south)
   
#beach <- rep(1:3,length.out=N+startbabies) # each turtle has a beach on which it was born (1=north, 2=east, 3=south)
  # temperature----
  # temperature data from http://www.bom.gov.au/climate/change/index.shtml#tabs=Tracker&tracker=timeseries&tQ=graph%3Dtmean%26area%3Dqld%26season%3D12%26ave_yr%3D0
  # for eastern australia december
  # 
  # for timeframe before 1910, we assume tpiv
  # the future temperature will be determined by the growth of CO2
  # growth is constant, low, moderate or high
  load("starter_temperature.RData")
  temp<-switch(as.character(climate),constant=temp_co,low=temp_lo,moderate=temp_mo,high=temp_hi)
  
# loop over years-----
  #START MAIN LOOP---------------
  xx<-1
  # realtemp<-temp[111:220]
  for (year in 1:obs_time){
    if(!year%in%(which(timeframe==1883)):(which(timeframe==1883)+length(realtemp)-1)){
      temp[year]<-rnorm(1,mean=temp[year],sd=sd(realtemp))
    }
    if(timeframe[year]==2018){
      cursera<-c(sum(sex[age<=20]==1)/sum(age<=20),sum(sex[age<=40]==1)/sum(age<=40),sum(sex[age>40]==1)/sum(age>40))
      }
    if (length(ID)>0){
      popsize[year] <- length(ID)#+length(which(juveniles!=-1))/4
      females[year] <- sum(sex==1 & age>=(maturage))/(length(ID))#+length(which(juveniles!=-1))/4)
      
      meangene[year] <- mean(genes[1,1:2,genes[1,1,]!=-1],na.rm = TRUE)
      meanenzyme[year] <- mean(genes[2,1:2,genes[2,1,]!=-1],na.rm = TRUE)
      meanshade[year] <- mean(genes[3,1:2,genes[3,1,]!=-1],na.rm = TRUE)
      north[year] <- length(which(beach[1:length(ID)]==1))
      east[year] <- length(which(beach[1:length(ID)]==2))
      south[year] <- length(which(beach[1:length(ID)]==3))
      males <- which(sex==0 & age>(maturage-1))
      
      # loop over individuals-----
      # adult <- juveniles[55:57,,] 
      adult <- juveniles[(dim(juveniles)[1]-2):dim(juveniles)[1],,] 
      
      # juveniles[4:57,,] <- juveniles[1:54,,]
      juveniles[4:dim(juveniles)[1],,] <- juveniles[1:(dim(juveniles)[1]-3),,]
      
      juveniles[1:3,,] <- -1 
              for (i in which(sex==1 & age>(maturage-1) & mated>=3)) {

      if (length(males)>0){
        male_prob <- 1-(1-(1/area))^length(males)#length(males)/(K/2)
        find_mate <- runif(1,0,1)
        NM<-find_mate<male_prob
      }else{
        NM<-FALSE
      }
      SM<-southmate>runif(1,0,1)
      if(NM&SM){assign(c("NM","SM")[2],FALSE)}# if she meets both a northern&southern male, it is randomly chosen who she will mate with. 
      if (length(which(sex==1 & age>(maturage-1) & mated>=3))>0){
          # reproduction-----
          if (NM|SM){
            eggnumber <- rbinom(1,100,psurv)
            if (eggnumber>0){
              egg <- array(-1,dim=c(loci,2,eggnumber))
              if(NM){
                father<-sample(males,1)
              }else if (SM){
                stop("Something is going on in the south")
                father<-sample(1:dim(southmales)[3],1)
              }
              for(ii in 1:eggnumber){
                if(NM){
                  egg[,,ii] <- make_egg(genes[,,i],genes[,,father])
                }else if (SM){
                  egg[,,ii] <-  make_egg(genes[,,i],southmales[,,father])
                }
                mut <- (runif(1,0,1))
                if (mut<(sqrt(mura)/2)){
                  beach <- c(beach,sample((1:3)[-beach[i]],1))
                }else{
                  beach <- c(beach,beach[i])
                }
                eggtemp <- egg_temp(Mechanism,temp[year],deep,shady,yearly,howmany)
                femprob <- temperature(a,b,eggtemp)
                sex <- c(sex,rbinom(1,1,femprob))
                age <- c(age,0)
                mated <- c(mated, 0)
              }
              st <- min(which(juveniles[1,1,]==-1))
              juveniles[1:3,,st:(st+dim(egg)[3]-1)] <- egg[,,]
            } 
            mated[i] <- 0 
          }
        }
      }
      
      #adding new adults-----------------------
      if (sum(age==(maturage-1))>0){
        baby <- min(which(genes[1,1,]==-1))
        if(is.na(dim(adult)[3])){
          dim(adult)[3]<- 1
        }
        pk<-max(0,min(1,(K-length(ID))/sum(age==(maturage-1))))
        survis<-which(rbinom(sum(age==(maturage-1)),1,pk)==1) 
        if(length(survis)!=sum(age==(maturage-1))){
          
          if(length(survis)>=1){
            su<-which(age==(maturage-1))[-survis]
          }else{#if there are no survivours we still need to remove those of age (maturage-1)
            su<-which(age==(maturage-1))
          }
          sex<-sex[-su]
          mated<-mated[-su]
          age<-age[-su]
          beach<-beach[-su]
        }
        if(is.na(dim(adult[,,survis])[3])){
          dim(adult[,,survis])[3]<- 1
        }
        
        if(length(survis)>0){
          genes[,,baby:(baby+length(survis)-1)] <- adult[,,survis]
          ID <- c(ID,seq(id+1,id+length(survis),1))
          id <- id+length(survis)
        }
        
        
        
      }
      # death-----
      # deathrate depends on age of each turtle
      # those who are below the death rate die
      z <- which(runif(length(ID),0,1)<(1-ds[age[1:length(ID)]+1]))
      if (length(z)>0){
        ID <- ID[-z]
        if (length(ID)>0){ # if they all die, they're NaN (down below)
          genes<-array(c(genes[,,-z],numeric(length(z)*2*(3))-1),dim=c(3,2,dim(genes)[3]))
          age <- age[-z]
          sex <- sex[-z]
          beach <- beach[-z]
          mated <- mated[-z]
        }
      }
      age <- age+1
      mated <- mated+1
    }else {
      popsize[year] <- NaN
      females[year] <- NaN
      meangene[year] <- NaN
      meanenzyme[year] <- NaN
      north[year] <- NaN
      east[year] <- NaN
      south[year] <- NaN
      meanshade[year] <- NaN
    }
    
  }
  meanshade<-meanshade*30
  
  save(list=ls(),file=paste0('RESULTS/Turtle_',W1,"_",W2,"_",W3,"_",sprintf("%07d", idx2),'.RData'))
  
  # png(filename=paste0("Graphs",W1,"_",W2,"_",W3,"_",sprintf("%07d", idx2),".png"),width=2000,height=700)
  # par(mfrow=c(2,3),mar=c(bottom=4.5,left=7,top=1.5,right=.4),cex.lab=3,cex.axis=2,mgp=c(3, .7, 0),xaxs='i',yaxs='i')
  # plottingvectors<-c("popsize","females","meangene","meanenzyme","meanshade")
  # for(i in 1:length(plottingvectors)){
  #   plot(timeframe,get(plottingvectors[i]),type='l',lwd=5,xlab="Year",ylab=plottingvectors[i])
  #   abline(v=c(1910,2019),col="gray53",lty=3)
  # }
  # matplot(timeframe,cbind(north,east,south)/rowSums(cbind(north,east,south)),type='l',lwd=5,xlab="Year",col=rev(viridis::plasma(3)),lty=1)
  # legend("topleft",c("North","East","South"),col=rev(viridis::plasma(3)),pch=15)
  # abline(v=c(1910,2019),col="gray53",lty=3)  
  # graphics.off()
  
  #--------------------------------
  
  
} #end of     if(length(commandArgs(trailingOnly=T)) >= idx1){
# 

